#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Fri Sep 23 09:35:42 2022

@author: frederic
"""
from classe_animal import *
from classe_vecteur import *
from random import random, randint

class Nuee:
    """
    Attribut de classe :
        vecteur_nul : comme son nom l'indique, objet de type Vecteur égal au vecteur nul
        max_voisins : nombre maximum de voisins. Non utilisé
    Attributs :
        essaim : liste d'objets de type Animal. Le nombre est donné en paramètre du constructeur
        l_univers, h_univers : entiers, largeur et hauteur 
            de l'univers/la grille (en pixels) dans laquelle évolue la nuée
        force_vent : une force qui change de temps en temps, qui exprime un vent 
                ou une direction dominante à suivre pour l'essaim
    Méthodes :
        mouvement :
            Met à jour la position de tous les animaux de la nuée
        regles :
            Applique à chaque animal les réègles de séparation, cohésion et alignement
        voisins :
            Etant donnée une distance de voisinage, renvoie trois listes de tous 
            les voisins de chaque animal. Il y a une liste par distance de perception :
            une pour la distance de séparation, une pour la distance d'alignement, et 
            une pour la distance de cohésion.
            Ces listes sont sous la forme d'une liste de liste de
            booléens : booléen[i][j] est vrai si l'animal i a pour voisin j.
            Attention ces matrices ns pas symétriques, si l'on considère que
            les animaux ont un champ de vision de moins de 360 degrés.
        separation : permet aux animaux de ne pas s'approcher trop près. Pour
            chaque animal, l'éloigne des animaux trop proches
        alignement : permet aux animaux d'aller dans la même direction. 
            Chaque animal se rapproche de la direction moyenne de ses voisins
        cohesion : permet aux animaux de se rapprocher.
            Chaque animal se rapproche de la position moyenne de ses voisins
        centripete : modifie les vitesses des animaux.
        fuite : en présence d'un prédateur, le fuit à un angle aléatoire entre 
            -90 et +90 degrés. Annule toutes les modifications dues aux fonctions
            séparation, alignement et cohésion
        
    """
    max_voisins = 10            # non utilisé dans cette version
    vecteur_nul = Vecteur(0, 0) # non utilisé dans cette version
    
    def __init__(self,nombre, l_univers, h_univers):
        self.essaim = []
        # Finir la construction de l'essaim
        
        self.force_vent = Vecteur(random()*2 - 1, random()*2 - 1)
        while self.force_vent == 0 :
            self.force_vent = Vecteur(random()*2 - 1, random()*2 - 1)
        self.force_vent.prodk(self.essaim[0].force_max/self.force_vent.norme())
        print(self.force_vent)
        self.force_vent.prodk(1/20)
    
    def mouvement(self):
        pass

    
    def regles(self, animal):
        if randint(1, 100) == 1 :
            self.force_vent = Vecteur(random()*2 - 1, random()*2 - 1)
            while self.force_vent == 0 :
                self.force_vent = Vecteur(random()*2 - 1, random()*2 - 1)
            self.force_vent.prodk(self.essaim[0].force_max/self.force_vent.norme())
            print(self.force_vent)
            self.force_vent.prodk(1/20)
        # A completer
        pass
    
    def voisins(self) :
        vois_sep = []
        vois_align = []
        vois_coh = []

        return vois_sep, vois_align, vois_coh
    

            
    def alignement(self, animal, liste_vois) :
        force_alignement = Vecteur(0, 0)
        
        return force_alignement
    
    def separation(self, animal, liste_vois):
        force_separation = Vecteur(0, 0)

        return force_separation
    
    def cohesion(self, animal, liste_vois):
        force_cohesion = Vecteur(0, 0)

        return force_cohesion
        
    def centripete(self, animal):
        force_centripete = Vecteur(-animal.vitesse.x, -animal.vitesse.y)
        return force_centripete
